Index: locale/en/mlx.po
===================================================================
--- locale/en/mlx.po	(revision 1084)
+++ locale/en/mlx.po	(revision 1085)
@@ -999,4 +999,13 @@
 msgid "simbrief_result_title"
 msgstr "SimBrief flight plan"
+
+msgid "simbrief_result_briefing"
+msgstr "Briefing:"
+
+msgid "simbrief_result_downloads"
+msgstr "Downloads:"
+
+msgid "simbrief_result_prefile"
+msgstr "Prefile flight plan:"
 
 msgid "briefing_title"
Index: locale/hu/mlx.po
===================================================================
--- locale/hu/mlx.po	(revision 1084)
+++ locale/hu/mlx.po	(revision 1085)
@@ -998,4 +998,13 @@
 msgid "simbrief_result_title"
 msgstr "SimBrief repülési terv"
+
+msgid "simbrief_result_briefing"
+msgstr "Eligazítás:"
+
+msgid "simbrief_result_downloads"
+msgstr "Letöltések:"
+
+msgid "simbrief_result_prefile"
+msgstr "Repülési terv beküldése:"
 
 msgid "briefing_title"
Index: src/mlx/gui/flight.py
===================================================================
--- src/mlx/gui/flight.py	(revision 1084)
+++ src/mlx/gui/flight.py	(revision 1085)
@@ -3747,4 +3747,6 @@
                     for weatherElement in weatherElementList:
                         flightInfo[weatherElement.tag] = weatherElement.text
+                elif element.tag in ["files", "prefile"]:
+                    availableInfo[element.tag] = element
                 else:
                     availableInfo[element.tag] = element.text
@@ -3762,5 +3764,59 @@
             htmlFilePath = SimBriefSetupPage.getHTMLFilePath()
             with open(htmlFilePath, 'w') as f:
+                f.write("<html>")
+                f.write("<body>")
+                f.write("<h3 style=\"text-align: center;\">%s</h3></br>" % (xstr("simbrief_result_briefing"),))
+                f.write("<div style=\"height: 300px; width: fit-content; overflow: auto; margin: 0 auto;\">")
                 f.write(availableInfo["plan_html"])
+                f.write("</div>\n")
+
+                f.write("<h2/>");
+                f.write("<h3 style=\"text-align: center;\">%s</h3></br>" % (xstr("simbrief_result_downloads"),))
+                f.write("<div style=\"height: 300px; width: fit-content; overflow: auto; margin: 0 auto\">")
+                f.write("<table style=\"border: 1px solid; border-collapse: collapse;\">")
+
+                directory = ""
+                for fileData in availableInfo["files"]:
+                    if fileData.tag=="directory":
+                        directory = fileData.text
+
+                for fileData in availableInfo["files"]:
+                    if fileData.tag in ["pdf", "file"]:
+                        name = fileData.find("name").text
+                        link = fileData.find("link").text
+
+                        f.write("<tr>")
+                        f.write("<td style=\"border: 1px solid; padding-left: 10px; padding-right: 10px; padding-top: 5px; padding-bottom: 5px;\">")
+                        f.write(name)
+                        f.write("</td>")
+                        f.write("<td style=\"border: 1px solid; padding-left: 10px; padding-right: 10px; padding-top: 5px; padding-bottom: 5px;\">")
+                        url = directory + link
+                        target = " target=\"_blank\"" if fileData.tag=="pdf" else ""
+                        f.write("<a href=\"%s\"%s>%s</a>" % (url, target, name))
+                        f.write("</td>")
+                        f.write("</tr>")
+
+                f.write("</table>")
+                f.write("</div>\n")
+
+                f.write("<h2/>")
+                f.write("<h3 style=\"text-align: center;\">%s</h3></br>" % (xstr("simbrief_result_prefile"),))
+                f.write("<div style=\"height: 400px; width: fit-content; margin: 0 auto\">")
+                f.write("<table style=\"border: 1px solid; border-collapse: collapse;\">")
+                for prefileData in availableInfo["prefile"]:
+                    name = prefileData.find("name").text
+                    link = prefileData.find("link").text
+                    f.write("<tr>")
+                    f.write("<td style=\"border: 1px solid; padding-left: 10px; padding-right: 10px; padding-top: 5px; padding-bottom: 5px;\">")
+                    f.write("<a href=\"%s\" target=\"_blank\">%s</a>" % (link, name))
+                    f.write("</td>");
+                    f.write("</tr>")
+
+                f.write("</table>")
+                f.write("</div>\n")
+
+                f.write("</body>")
+                f.write("</html>")
+
         except Exception as e:
             print("_getResults", e)
@@ -3815,5 +3871,10 @@
         def OnBeforeClose(self, browser):
             """Called before closing the browser."""
-            self._simBriefingPage._invalidateBrowser()
+            if browser is self._simBriefingPage._browser:
+                self._simBriefingPage._invalidateBrowser()
+
+        def OnBeforeDownload(self, browser, downloadItem, suggestedName, callback):
+            callback.Continue(suggestedName, True)
+            return True
 
     def __init__(self, wizard):
@@ -3823,11 +3884,8 @@
                                               xstr("simbrief_result_title"), "")
 
-        self._alignment = Gtk.Alignment(xalign = 0.5, yalign = 0.5,
-                                       xscale = 1.0, yscale = 1.0)
-
         self._container = cef.getContainer()
-        self._alignment.add(self._container)
-
-        self.setMainWidget(self._alignment)
+        self._container.set_size_request(650, -1)
+
+        self.setMainWidget(self._container)
 
         self._browser = None
@@ -3881,5 +3939,5 @@
         if self._container is None:
             self._container = cef.getContainer()
-            self._alignment.add(self._container)
+            self.setMainWidget(self._container)
         else:
             self._container.show()