Index: src/mlx/config.py
===================================================================
--- src/mlx/config.py	(revision 1084)
+++ src/mlx/config.py	(revision 1094)
@@ -249,4 +249,6 @@
         self._pilotHotkey = Hotkey(ctrl = True, shift = False, key = "0")
 
+        self._taxiSoundOnPushback = False
+
         self._enableApproachCallouts = False
         self._speedbrakeAtTD = True
@@ -608,4 +610,16 @@
         if pilotHotkey!=self._pilotHotkey:
             self._pilotHotkey = pilotHotkey
+            self._modified = True
+
+    @property
+    def taxiSoundOnPushback(self):
+        """Get whether the taxi sound should be played as soon as pushback starts."""
+        return self._taxiSoundOnPushback
+
+    @taxiSoundOnPushback.setter
+    def taxiSoundOnPushback(self, taxiSoundOnPushback):
+        """Set whether the taxi sound should be played as soon as pushback starts."""
+        if taxiSoundOnPushback!=self._taxiSoundOnPushback:
+            self._taxiSoundOnPushback = taxiSoundOnPushback
             self._modified = True
 
@@ -802,4 +816,7 @@
         self._pilotHotkey.set(self._get(config, "sounds",
                                         "pilotHotkey", "C0"))
+
+        self._taxiSoundOnPushback = \
+            self._getBoolean(config, "sounds", "taxiSoundOnPushback", False)
         self._enableApproachCallouts = \
             self._getBoolean(config, "sounds", "enableApproachCallouts", False)
@@ -903,4 +920,6 @@
                    "yes" if self._pilotControlsSounds else "no")
         config.set("sounds", "pilotHotkey", str(self._pilotHotkey))
+        config.set("sounds", "taxiSoundOnPushback",
+                   "yes" if self._taxiSoundOnPushback else "no")
         config.set("sounds", "enableApproachCallouts",
                    "yes" if self._enableApproachCallouts else "no")
@@ -1047,4 +1066,6 @@
         print("  pilotHotkey:", str(self._pilotHotkey))
 
+        print("  taxiSoundOnPushback:", self._taxiSoundOnPushback)
+
         print("  enableApproachCallouts:", self._enableApproachCallouts)
         print("  speedbrakeAtTD:", self._speedbrakeAtTD)
Index: src/mlx/gui/prefs.py
===================================================================
--- src/mlx/gui/prefs.py	(revision 1067)
+++ src/mlx/gui/prefs.py	(revision 1094)
@@ -270,4 +270,6 @@
         self._enableChecklists.set_active(config.enableChecklists)
         self._checklistHotkey.set(config.checklistHotkey)
+
+        self._taxiSoundOnPushback.set_active(config.taxiSoundOnPushback)
 
         self._autoUpdate.set_active(config.autoUpdate)
@@ -321,4 +323,6 @@
         config.checklistHotkey = self._checklistHotkey.get()
 
+        config.taxiSoundOnPushback = self._taxiSoundOnPushback.get_active()
+
         config.autoUpdate = self._autoUpdate.get_active()
         config.updateURL = self._updateURL.get_text()
@@ -700,4 +704,9 @@
         backgroundBox.pack_start(self._pilotHotkey, False, False, 4)
 
+        self._taxiSoundOnPushback = Gtk.CheckButton(xstr("prefs_sounds_taxiSoundOnPushback"))
+        self._taxiSoundOnPushback.set_use_underline(True)
+        self._taxiSoundOnPushback.set_tooltip_text(xstr("prefs_sounds_taxiSoundOnPushback_tooltip"))
+        backgroundBox.pack_start(self._taxiSoundOnPushback, False, False, 4)
+
         self._enableApproachCallouts = Gtk.CheckButton(xstr("prefs_sounds_approachCallouts"))
         self._enableApproachCallouts.set_use_underline(True)
@@ -750,4 +759,5 @@
         self._pilotControlsSounds.set_sensitive(active)
         self._pilotControlsSoundsToggled(self._pilotControlsSounds)
+        self._taxiSoundOnPushback.set_sensitive(active)
         self._enableApproachCallouts.set_sensitive(active)
         self._speedbrakeAtTD.set_sensitive(active)
Index: src/mlx/soundsched.py
===================================================================
--- src/mlx/soundsched.py	(revision 919)
+++ src/mlx/soundsched.py	(revision 1094)
@@ -149,9 +149,11 @@
     def __init__(self, flight, boardingSound = None):
         """Construct the taxi sound."""
+        config = flight.config
+
         super(TaxiSound, self).__init__(const.SOUND_MALEV,
                                         const.STAGE_PUSHANDTAXI,
                                         previousSound = boardingSound,
                                         extraCondition = lambda _flight, state:
-                                        state.groundSpeed>5)
+                                        config.taxiSoundOnPushback or state.groundSpeed>5)
 
         self._flight = flight