Index: locale/en/mlx.po
===================================================================
--- locale/en/mlx.po	(revision 1098)
+++ locale/en/mlx.po	(revision 1123)
@@ -1890,4 +1890,14 @@
 "If checked, a speedbrake sound will be played after touchdown, "
 "when the speedbrakes deploy."
+
+msgid "prefs_sounds_alternativeSoundSet"
+msgstr "Use an a_lternative sound set"
+
+msgid "prefs_sounds_alternativeSoundSet_tooltip"
+msgstr ""
+"If checked, an alternative set of sound recording will be used, when available. "
+"Currently, an extended version of the taxi sounds is played, which includes "
+"the original Malév safety demo when flying a Boeing 737 or 767 aircraft. "
+"The rest of the recordings remains unchanged."
 
 msgid "prefs_sounds_frame_checklists"
Index: locale/hu/mlx.po
===================================================================
--- locale/hu/mlx.po	(revision 1098)
+++ locale/hu/mlx.po	(revision 1123)
@@ -1902,4 +1902,15 @@
 "Ha kijelölöd, egy, a spoilerek kibocsájtását imitáló hang "
 "hallatszik földetérés után, ha a spoilerek automatikusan kinyílnak."
+
+msgid "prefs_sounds_alternativeSoundSet"
+msgstr "Al_ternatív hangkészlet használata"
+
+msgid "prefs_sounds_alternativeSoundSet_tooltip"
+msgstr ""
+"Ha bejelölöd, alternatív hangkészletet használ a program bizonyos esetekben. "
+"Jelenleg Boeing 737 és 767 típusú gépeknél a gurulás során lejátszott hangfelvétel "
+"a korábban és alapértelmezésben jelenleg is használtnak egy kibővített változata, "
+"amely a Malév eredeti biztonsági bemutatóját is tartalmazza. "
+"A többi hangfelvétel ugyanaz, mint korábban is."
 
 msgid "prefs_sounds_frame_checklists"
Index: src/mlx/config.py
===================================================================
--- src/mlx/config.py	(revision 1098)
+++ src/mlx/config.py	(revision 1123)
@@ -255,4 +255,5 @@
         self._enableApproachCallouts = False
         self._speedbrakeAtTD = True
+        self._soundSet = 0
 
         self._enableChecklists = False
@@ -672,4 +673,16 @@
         if speedbrakeAtTD!=self._speedbrakeAtTD:
             self._speedbrakeAtTD = speedbrakeAtTD
+            self._modified = True
+
+    @property
+    def soundSet(self):
+        """Get the number of the  sound set to use."""
+        return self._soundSet
+
+    @soundSet.setter
+    def soundSet(self, soundSet):
+        """Set the number of the sound set."""
+        if soundSet!=self._soundSet:
+            self._soundSet = soundSet
             self._modified = True
 
@@ -856,4 +869,6 @@
         self._speedbrakeAtTD = self._getBoolean(config, "sounds",
                                                 "speedbrakeAtTD", True)
+        self._soundSet = self._getInteger(config, "sounds",
+                                          "soundSet", 0)
 
         self._enableChecklists = self._getBoolean(config, "sounds",
@@ -963,4 +978,5 @@
         config.set("sounds", "speedbrakeAtTD",
                    "yes" if self._speedbrakeAtTD else "no")
+        config.set("sounds", "soundSet", str(self._soundSet))
 
         config.set("sounds", "enableChecklists",
@@ -998,4 +1014,11 @@
         otherwise the default."""
         return config.getboolean(section, option) \
+               if config.has_option(section, option) \
+               else default
+
+    def _getInteger(self, config, section, option, default):
+        """Get the given option as an integer, if found in the given config,
+        otherwise the default."""
+        return config.getint(section, option) \
                if config.has_option(section, option) \
                else default
@@ -1109,4 +1132,5 @@
         print("  enableApproachCallouts:", self._enableApproachCallouts)
         print("  speedbrakeAtTD:", self._speedbrakeAtTD)
+        print("  soundSet:", self._soundSet)
 
         print("  enableChecklists:", self._enableChecklists)
Index: src/mlx/const.py
===================================================================
--- src/mlx/const.py	(revision 1117)
+++ src/mlx/const.py	(revision 1123)
@@ -461,6 +461,12 @@
 SOUND_TAXI_BOEING737NG = "737taxi.mp3"
 
+## Sound: taxi: Boeing 737 NG (alternative variant)
+SOUND_TAXI_BOEING737NG_ALT1 = "737taxi_1.mp3"
+
 ## Sound: taxi: Boeing 767
 SOUND_TAXI_BOEING767 = "767taxi.mp3"
+
+## Sound: taxi: Boeing 767 (alternative variant)
+SOUND_TAXI_BOEING767_ALT1 = "767taxi_1.mp3"
 
 ## Sound: taxi: Fokker F70
Index: src/mlx/gui/prefs.py
===================================================================
--- src/mlx/gui/prefs.py	(revision 1098)
+++ src/mlx/gui/prefs.py	(revision 1123)
@@ -268,4 +268,5 @@
         self._enableApproachCallouts.set_active(config.enableApproachCallouts)
         self._speedbrakeAtTD.set_active(config.speedbrakeAtTD)
+        self._alternativeSoundSet.set_active(config.soundSet!=0)
 
         self._enableChecklists.set_active(config.enableChecklists)
@@ -321,4 +322,5 @@
         config.enableApproachCallouts = self._enableApproachCallouts.get_active()
         config.speedbrakeAtTD = self._speedbrakeAtTD.get_active()
+        config.soundSet = 1 if self._alternativeSoundSet.get_active() else 0
 
         config.enableChecklists = self._enableChecklists.get_active()
@@ -726,4 +728,10 @@
         backgroundBox.pack_start(self._speedbrakeAtTD, False, False, 4)
 
+        self._alternativeSoundSet = Gtk.CheckButton(xstr("prefs_sounds_alternativeSoundSet"))
+        self._alternativeSoundSet.set_use_underline(True)
+        self._alternativeSoundSet.set_tooltip_text(
+            xstr("prefs_sounds_alternativeSoundSet_tooltip"))
+        backgroundBox.pack_start(self._alternativeSoundSet, False, False, 4)
+
         checklistFrame = Gtk.Frame(label = xstr("prefs_sounds_frame_checklists"))
         mainBox.pack_start(checklistFrame, False, False, 4)
@@ -769,4 +777,5 @@
         self._enableApproachCallouts.set_sensitive(active)
         self._speedbrakeAtTD.set_sensitive(active)
+        self._alternativeSoundSet.set_sensitive(active)
 
     def _pilotControlsSoundsToggled(self, button):
Index: src/mlx/soundsched.py
===================================================================
--- src/mlx/soundsched.py	(revision 1094)
+++ src/mlx/soundsched.py	(revision 1123)
@@ -139,11 +139,19 @@
     played."""
 
-    _sounds = { const.AIRCRAFT_B736  : const.SOUND_TAXI_BOEING737NG,
-                const.AIRCRAFT_B737  : const.SOUND_TAXI_BOEING737NG,
-                const.AIRCRAFT_B738  : const.SOUND_TAXI_BOEING737NG,
-                const.AIRCRAFT_B738C : const.SOUND_TAXI_BOEING737NG,
-                const.AIRCRAFT_B762  : const.SOUND_TAXI_BOEING767,
-                const.AIRCRAFT_B763  : const.SOUND_TAXI_BOEING767,
-                const.AIRCRAFT_F70   : const.SOUND_TAXI_F70 }
+    _sounds = [{ const.AIRCRAFT_B736  : const.SOUND_TAXI_BOEING737NG,
+                 const.AIRCRAFT_B737  : const.SOUND_TAXI_BOEING737NG,
+                 const.AIRCRAFT_B738  : const.SOUND_TAXI_BOEING737NG,
+                 const.AIRCRAFT_B738C : const.SOUND_TAXI_BOEING737NG,
+                 const.AIRCRAFT_B762  : const.SOUND_TAXI_BOEING767,
+                 const.AIRCRAFT_B763  : const.SOUND_TAXI_BOEING767,
+                 const.AIRCRAFT_F70   : const.SOUND_TAXI_F70 },
+               { const.AIRCRAFT_B736  : const.SOUND_TAXI_BOEING737NG_ALT1,
+                 const.AIRCRAFT_B737  : const.SOUND_TAXI_BOEING737NG_ALT1,
+                 const.AIRCRAFT_B738  : const.SOUND_TAXI_BOEING737NG_ALT1,
+                 const.AIRCRAFT_B738C : const.SOUND_TAXI_BOEING737NG_ALT1,
+                 const.AIRCRAFT_B762  : const.SOUND_TAXI_BOEING767_ALT1,
+                 const.AIRCRAFT_B763  : const.SOUND_TAXI_BOEING767_ALT1,
+                 const.AIRCRAFT_F70   : const.SOUND_TAXI_F70 },
+               ]
 
     def __init__(self, flight, boardingSound = None):
@@ -165,5 +173,9 @@
         super(TaxiSound, self)._playbackDone(success, extra)
         aircraftType = self._flight.aircraftType
+
+        soundSet = self._flight.config.soundSet
         sounds = TaxiSound._sounds
+        sounds = sounds[soundSet] if soundSet<len(sounds) else sounds[-1]
+
         if aircraftType in sounds:
             startSound(sounds[aircraftType])