Index: locale/en/mlx.po
===================================================================
--- locale/en/mlx.po	(revision 1139)
+++ locale/en/mlx.po	(revision 1144)
@@ -653,4 +653,7 @@
 msgstr "Too many infants (maximum: %d)."
 
+msgid "payload_flight_type"
+msgstr "Flight type:"
+
 msgid "payload_crew"
 msgstr "C_rew:"
@@ -660,5 +663,5 @@
 
 msgid "payload_crew_info"
-msgstr "cockpit + cabin"
+msgstr "cockpit + cabin (%d kg)"
 
 msgid "payload_pax"
@@ -675,5 +678,5 @@
 
 msgid "payload_pax_info"
-msgstr "adults + children + infants"
+msgstr "adults (%d kg) + children (%d kg) +\ninfants (%d kg)"
 
 msgid "payload_bag"
@@ -1549,9 +1552,18 @@
 "<b><span foreground=\"orange\">yellow</span></b>."
 
+msgid "weighthelp_flight_type"
+msgstr "Flight type:"
+
 msgid "weighthelp_crew"
 msgstr "Crew (%s):"
 
+msgid "weighthelp_crew_info"
+msgstr "(DOW cabin crew: %s)"
+
 msgid "weighthelp_pax"
 msgstr "Passengers (%s):"
+
+msgid "weighthelp_pax_info"
+msgstr "(adult: %s kg, child: %s kg\ninfant: %s kg)"
 
 msgid "weighthelp_baggage"
Index: locale/hu/mlx.po
===================================================================
--- locale/hu/mlx.po	(revision 1139)
+++ locale/hu/mlx.po	(revision 1144)
@@ -657,4 +657,7 @@
 msgstr "Túl sok csecsemő (legfeljebb %d lehet)."
 
+msgid "payload_flight_type"
+msgstr "Járattípus:"
+
 msgid "payload_crew"
 msgstr "_Legénység:"
@@ -664,5 +667,5 @@
 
 msgid "payload_crew_info"
-msgstr "pilóta + kabin"
+msgstr "pilóta + kabin (%d kg)"
 
 msgid "payload_pax"
@@ -679,5 +682,5 @@
 
 msgid "payload_pax_info"
-msgstr "felnőtt + gyermek + csecsemő"
+msgstr "felnőtt (%d kg) + gyermek (%d kg) + csecsemő (%d kg)"
 
 msgid "payload_bag"
@@ -1552,9 +1555,18 @@
 "<b><span foreground=\"orange\">sárga</span></b> színben olvasható."
 
+msgid "weighthelp_flight_type"
+msgstr "Járattípus:"
+
 msgid "weighthelp_crew"
 msgstr "Legénység (%s):"
 
+msgid "weighthelp_crew_info"
+msgstr "(DOW kabin személyzet: %s fő)"
+
 msgid "weighthelp_pax"
 msgstr "Utasok (%s):"
+
+msgid "weighthelp_pax_info"
+msgstr "(felnőtt: %s kg, gyermek: %s kg\ncsecsemő: %s kg)"
 
 msgid "weighthelp_baggage"
Index: src/mlx/gui/flight.py
===================================================================
--- src/mlx/gui/flight.py	(revision 1143)
+++ src/mlx/gui/flight.py	(revision 1144)
@@ -2427,5 +2427,5 @@
                                   xscale = 0.0, yscale = 0.0)
 
-        table = Gtk.Table(7, 3)
+        table = Gtk.Table(8, 3)
         table.set_row_spacings(4)
         table.set_col_spacings(16)
@@ -2436,4 +2436,14 @@
         row  = 0
 
+        label = Gtk.Label(xstr("payload_flight_type"))
+        label.set_alignment(0.0, 0.5)
+        table.attach(label, 0, 1, row, row+1)
+
+        self._flightType = label = Gtk.Label(xstr("flighttype_scheduled"))
+        label.set_alignment(1.0, 0.5)
+        table.attach(label, 1, 2, row, row + 1)
+
+        row += 1
+
         self._crewLabel = label = Gtk.Label(xstr("payload_crew"))
         label.set_use_underline(True)
@@ -2457,5 +2467,5 @@
         label.set_mnemonic_widget(self._numCabinCrew)
 
-        label = Gtk.Label(xstr("payload_crew_info"))
+        label = Gtk.Label(xstr("payload_crew_info") % (const.WEIGHT_CABIN_CREW))
         label.set_halign(Gtk.Align.START)
         table.attach(label, 2, 3, row, row+1)
@@ -2493,5 +2503,6 @@
         label.set_mnemonic_widget(self._numPassengers)
 
-        label = Gtk.Label(xstr("payload_pax_info"))
+        self._paxInfo = label = Gtk.Label(xstr("payload_pax_info") % (
+            const.WEIGHT_PASSENGER, const.WEIGHT_CHILD, const.WEIGHT_INFANT))
         label.set_halign(Gtk.Align.START)
         table.attach(label, 2, 3, row, row+1)
@@ -2638,4 +2649,10 @@
         """Setup the information."""
         bookedFlight = self._wizard._bookedFlight
+
+        self._flightType.set_text(xstr("flighttype_" +
+                                       const.flightType2string(bookedFlight.flightType)))
+
+        self._paxInfo.set_text(xstr("payload_pax_info") % (
+            bookedFlight.passengerWeight, const.WEIGHT_CHILD, const.WEIGHT_INFANT))
 
         self._numCockpitCrew.set_markup("<b>" +
Index: src/mlx/gui/weighthelp.py
===================================================================
--- src/mlx/gui/weighthelp.py	(revision 1143)
+++ src/mlx/gui/weighthelp.py	(revision 1144)
@@ -58,5 +58,5 @@
 
         
-        self._weightsTable = table = Gtk.Table(16, 5)
+        self._weightsTable = table = Gtk.Table(17, 5)
         table.set_homogeneous(False)
         table.set_row_spacings(4)
@@ -95,4 +95,13 @@
 
         
+        label = Gtk.Label(xstr("weighthelp_flight_type"))
+        label.set_alignment(0.0, 0.5)
+        table.attach(label, 0, 1, row, row+1)
+
+        self._flightTypeLabel = label = Gtk.Label(xstr("flighttype_scheduled"))
+        label.set_alignment(1.0, 0.5)
+        table.attach(label, 1, 2, row, row + 1)
+
+        row += 1
 
         self._crewLabel = Gtk.Label(xstr("weighthelp_crew") % ("99",))
@@ -109,4 +118,10 @@
         
         table.attach(Gtk.Label("kg"), 2, 3, row, row+1)
+
+        self._crewInfo = Gtk.Label(xstr("weighthelp_crew_info") % ("-",))
+        alignment = Gtk.Alignment(xalign = 0.0, yalign = 0.5,
+                                  xscale = 0.0, yscale = 0.0)
+        alignment.add(self._crewInfo)
+        table.attach(alignment, 3, 5, row, row+1)
         
         row += 1
@@ -129,4 +144,11 @@
         table.attach(Gtk.Label("kg"), 2, 3, row, row+1)
         
+        self._paxInfo = Gtk.Label(xstr("weighthelp_pax_info") %
+                                  ("-", "-", "-"))
+        alignment = Gtk.Alignment(xalign = 0.0, yalign = 0.5,
+                                  xscale = 0.0, yscale = 0.0)
+        alignment.add(self._paxInfo)
+        table.attach(alignment, 3, 5, row, row+1)
+
         row += 1
 
@@ -382,11 +404,18 @@
         crewWeight = self._getCrewWeight()
         if crewWeight is None:
+            self._flightTypeLabel.set_text("-")
             self._crewLabel.set_text(xstr("weighthelp_crew") % ("-",))
             self._crewWeight.set_text("-")
-        else:
+            self._crewInfo.set_text(xstr("weighthelp_crew_info") % ("-",))
+        else:
+            self._flightTypeLabel.set_text(xstr("flighttype_" +
+                                                const.flightType2string(self._flightType)))
             self._crewLabel.set_text(xstr("weighthelp_crew") %
                                     (str(self._cockpitCrew) + "+" +
                                      str(self._cabinCrew),))
             self._crewWeight.set_text("%.0f" % (crewWeight,))
+            self._crewInfo.set_text(xstr("weighthelp_crew_info") %
+                                    (self._dowCabinCrew,))
+
 
         paxWeight = self._getPaxWeight()
@@ -394,4 +423,5 @@
             self._paxLabel.set_text(xstr("weighthelp_pax") % ("-",))
             self._paxWeight.set_text("-")
+            self._paxInfo.set_text(xstr("weighthelp_pax_info") % ("-", "-", "-"))
         else:
             self._paxLabel.set_text(xstr("weighthelp_pax") %
@@ -400,4 +430,7 @@
                                      str(self._infants),))
             self._paxWeight.set_text("%.0f" % (paxWeight,))
+            self._paxInfo.set_text(xstr("weighthelp_pax_info") %
+                                   (const.getPassengerWeight(self._flightType),
+                                    const.WEIGHT_CHILD, const.WEIGHT_INFANT))
 
         self._setWeightLabel(self._bagWeight, self._bag)