Index: src/mlx/config.py
===================================================================
--- src/mlx/config.py	(revision 1168)
+++ src/mlx/config.py	(revision 1184)
@@ -77,5 +77,5 @@
         """Create a checklist for the given aircraft type from the given
         config."""
-        baseName = "checklist." + const.icaoCodes[aircraftType] + "."
+        baseName = "checklist." + const.extendedICAOCodes[aircraftType] + "."
         fileList = []
         while True:
@@ -98,5 +98,5 @@
     def toConfig(self, config, aircraftType):
         """Add this checklist to the given config."""
-        baseName = "checklist." + const.icaoCodes[aircraftType] + "."
+        baseName = "checklist." + const.extendedICAOCodes[aircraftType] + "."
         for index in range(0, len(self._fileList)):
             option = baseName + str(index)
@@ -135,5 +135,5 @@
         """Create a checklist for the given aircraft type from the given
         config."""
-        baseName = "callouts." + const.icaoCodes[aircraftType] + "."
+        baseName = "callouts." + const.extendedICAOCodes[aircraftType] + "."
         mapping = {}
         while True:
@@ -161,5 +161,5 @@
     def toConfig(self, config, aircraftType):
         """Add this checklist to the given config."""
-        baseName = "callouts." + const.icaoCodes[aircraftType] + "."
+        baseName = "callouts." + const.extendedICAOCodes[aircraftType] + "."
         index = 0
         for (altitude, path) in self._mapping.items():
@@ -1147,5 +1147,5 @@
         print("  checklists:")
         for (type, checklist) in self._checklists.items():
-            print("    %s:" % (const.icaoCodes[type],))
+            print("    %s:" % (const.extendedICAOCodes[type],))
             for path in checklist:
                 print("      " + path)
@@ -1153,5 +1153,5 @@
         print("  approachCallouts:")
         for (type, approachCallouts) in self._approachCallouts.items():
-            print("    %s:" % (const.icaoCodes[type],))
+            print("    %s:" % (const.extendedICAOCodes[type],))
             for (altitude, path) in approachCallouts:
                 print("      %d: %s" % (altitude, path))
Index: src/mlx/const.py
===================================================================
--- src/mlx/const.py	(revision 1183)
+++ src/mlx/const.py	(revision 1184)
@@ -214,5 +214,5 @@
               AIRCRAFT_B737  : "B737",
               AIRCRAFT_B738  : "B738",
-              AIRCRAFT_B738C : "B738C",
+              AIRCRAFT_B738C : "B738",
               AIRCRAFT_B732  : "B732",
               AIRCRAFT_B733  : "B733",
@@ -230,4 +230,10 @@
               AIRCRAFT_B462  : "B462" }
 
+## A mapping of aircraft types to their 'extended' ICAO codes, which
+# are usually the same as the 'internal' ones above, but in certain
+# cases 'sub-types' are distinguished
+extendedICAOCodes = icaoCodes.copy()
+extendedICAOCodes[AIRCRAFT_B738C] = "B738C"
+
 #-------------------------------------------------------------------------------
 
Index: src/mlx/gui/flightlist.py
===================================================================
--- src/mlx/gui/flightlist.py	(revision 1033)
+++ src/mlx/gui/flightlist.py	(revision 1184)
@@ -246,5 +246,5 @@
         type."""
         return tailNumber + \
-            " (" + const.icaoCodes[bookedFlight.aircraftType] + ")"
+            " (" + const.extendedICAOCodes[bookedFlight.aircraftType] + ")"
 
     def _getAcft(tailNumber, bookedFlight):
Index: src/mlx/gui/pirep.py
===================================================================
--- src/mlx/gui/pirep.py	(revision 1079)
+++ src/mlx/gui/pirep.py	(revision 1184)
@@ -323,5 +323,5 @@
         self._callsign.set_text(bookedFlight.callsign)
         self._tailNumber.set_text(bookedFlight.tailNumber)
-        aircraftType = xstr("aircraft_" + icaoCodes[bookedFlight.aircraftType].lower())
+        aircraftType = xstr("aircraft_" + extendedICAOCodes[bookedFlight.aircraftType].lower())
         self._aircraftType.set_text(aircraftType)
 
@@ -888,5 +888,5 @@
         self._callsign.set_text(bookedFlight.callsign)
         self._tailNumber.set_text(bookedFlight.tailNumber)
-        aircraftType = xstr("aircraft_" + icaoCodes[bookedFlight.aircraftType].lower())
+        aircraftType = xstr("aircraft_" + extendedICAOCodes[bookedFlight.aircraftType].lower())
         self._aircraftType.set_text(aircraftType)
 